/[gentoo-x86]/eclass/depend.apache.eclass
Gentoo

Diff of /eclass/depend.apache.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.6 Revision 1.35
1# Copyright 2004 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License, v2 or later 2# Distributed under the terms of the GNU General Public License v2
3# Author Michael Tindal <urilith@gentoo.org>
4# $Header: /var/cvsroot/gentoo-x86/eclass/depend.apache.eclass,v 1.6 2004/11/21 01:51:58 urilith Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/depend.apache.eclass,v 1.35 2007/11/25 14:27:52 hollow Exp $
5ECLASS=depend.apache
6INHERITED="$INHERITED $ECLASS"
7 4
8###### 5# @ECLASS: depend.apache.eclass
9## Apache Common Variables 6# @MAINTAINER: apache-devs@gentoo.org
10## 7# @BLURB: Functions to allow ebuilds to depend on apache
11## These are internal variables used by this, and other apache-related eclasses, 8# @DESCRIPTION:
12## and thus should not need to be used by the ebuilds themselves (the ebuilds 9# This eclass handles depending on apache in a sane way and providing
13## should know what version of Apache they are building against). 10# information about where certain interfaces are located.
14###### 11#
12# @NOTE: If you use this, be sure you use the need_* call after you have defined
13# DEPEND and RDEPEND. Also note that you can not rely on the automatic
14# RDEPEND=DEPEND that portage does if you use this eclass.
15#
16# See bug 107127 for more information.
15 17
16#### 18inherit multilib
17## APACHE_VERSION 19
18## 20# ==============================================================================
21# INTERNAL VARIABLES
22# ==============================================================================
23
24# @ECLASS-VARIABLE: APACHE_VERSION
25# @DESCRIPTION:
19## Stores the version of apache we are going to be ebuilding. This variable is 26# Stores the version of apache we are going to be ebuilding. This variable is
20## set by the need_apache{|1|2} functions. 27# set by the need_apache functions.
21####
22APACHE_VERSION='2' 28#APACHE_VERSION="2"
23 29
24#### 30# @ECLASS-VARIABLE: APXS2
25## APXS1, APXS2 31# @DESCRIPTION:
26##
27## Paths to the apxs tools 32# Paths to the apxs tool
28####
29APXS1="/usr/sbin/apxs"
30APXS2="/usr/sbin/apxs2" 33APXS2="/usr/sbin/apxs2"
31 34
32#### 35# @ECLASS-VARIABLE: APACHECTL2
33## APACHECTL1, APACHECTL2 36# @DESCRIPTION:
34##
35## Paths to the apachectl tools 37# Path to the apachectl tool
36####
37APACHECTL1="/usr/sbin/apachectl"
38APACHECTL2="/usr/sbin/apache2ctl" 38APACHECTL2="/usr/sbin/apache2ctl"
39 39
40#### 40# @ECLASS-VARIABLE: APACHE2_BASEDIR
41## APACHE1_BASEDIR, APACHE2_BASEDIR 41# @DESCRIPTION:
42##
43## Paths to the server root directories 42# Path to the server root directory
44####
45APACHE1_BASEDIR="/usr/lib/apache"
46APACHE2_BASEDIR="/usr/lib/apache2" 43APACHE2_BASEDIR="/usr/$(get_libdir)/apache2"
47 44
48#### 45# @ECLASS-VARIABLE: APACHE2_CONFDIR
49## APACHE1_CONFDIR, APACHE2_CONFDIR 46# @DESCRIPTION:
50##
51## Paths to the configuration file directories (usually under 47# Path to the configuration file directory
52## $APACHE?_BASEDIR/conf)
53####
54APACHE1_CONFDIR="/etc/apache"
55APACHE2_CONFDIR="/etc/apache2" 48APACHE2_CONFDIR="/etc/apache2"
56 49
57#### 50# @ECLASS-VARIABLE: APACHE2_MODULES_CONFDIR
58## APACHE1_MODULES_CONFDIR, APACHE2_MODULES_CONFDIR 51# @DESCRIPTION:
59##
60## Paths where module configuration files are kept 52# Path where module configuration files are kept
61####
62APACHE1_MODULES_CONFDIR="${APACHE1_CONFDIR}/modules.d"
63APACHE2_MODULES_CONFDIR="${APACHE2_CONFDIR}/modules.d" 53APACHE2_MODULES_CONFDIR="${APACHE2_CONFDIR}/modules.d"
64 54
65#### 55# @ECLASS-VARIABLE: APACHE2_VHOSTDIR
66## APACHE1_MODULES_VHOSTDIR, APACHE2_MODULES_VHOSTDIR 56# @DESCRIPTION:
67##
68## Paths where virtual host configuration files are kept 57# Path where virtual host configuration files are kept
69####
70APACHE1_VHOSTDIR="${APACHE1_CONFDIR}/vhosts.d"
71APACHE2_VHOSTDIR="${APACHE2_CONFDIR}/vhosts.d" 58APACHE2_VHOSTDIR="${APACHE2_CONFDIR}/vhosts.d"
72 59
73#### 60# @ECLASS-VARIABLE: APACHE2_MODULESDIR
74## APACHE1_MODULESDIR, APACHE2_MODULESDIR 61# @DESCRIPTION:
75##
76## Paths where we install modules 62# Path where we install modules
77####
78APACHE1_MODULESDIR="${APACHE1_BASEDIR}/modules"
79APACHE2_MODULESDIR="${APACHE2_BASEDIR}/modules" 63APACHE2_MODULESDIR="${APACHE2_BASEDIR}/modules"
80 64
81#### 65# @ECLASS-VARIABLE: APACHE2_DEPEND
82## APACHE1_DEPEND, APACHE2_DEPEND 66# @DESCRIPTION:
83##
84## Dependencies for apache 1.x and apache 2.x 67# Dependencies for Apache 2.x
85####
86APACHE1_DEPEND="=net-www/apache-1*"
87APACHE2_DEPEND="=net-www/apache-2*" 68APACHE2_DEPEND="=www-servers/apache-2*"
88 69
89#### 70# @ECLASS-VARIABLE: APACHE2_0_DEPEND
90## need_apache1 71# @DESCRIPTION:
91## 72# Dependencies for Apache 2.0.x
73APACHE2_0_DEPEND="=www-servers/apache-2.0*"
74
75# @ECLASS-VARIABLE: APACHE2_2_DEPEND
76# @DESCRIPTION:
77# Dependencies for Apache 2.2.x
78APACHE2_2_DEPEND="=www-servers/apache-2.2*"
79
80# @ECLASS-VARIABLE: WANT_APACHE_DEPEND
81# @DESCRIPTION:
82# Dependency magic based on useflag to use the right DEPEND
83WANT_APACHE_DEPEND="apache2? ( ${APACHE2_DEPEND} )"
84
85# ==============================================================================
86# INTERNAL FUNCTIONS
87# ==============================================================================
88
89# @FUNCTION: uses_apache2
90# @DESCRIPTION:
91# sets up all of the environment variables required for an apache2 module
92uses_apache2() {
93 debug-print-function $FUNCNAME $*
94
95 # WARNING: Do not use these variables with anything that is put
96 # into the dependency cache (DEPEND/RDEPEND/etc)
97 APACHE_VERSION="2"
98 USE_APACHE="2"
99 APXS="${APXS2}"
100 APACHECTL="${APACHECTL2}"
101 APACHE_BASEDIR="${APACHE2_BASEDIR}"
102 APACHE_CONFDIR="${APACHE2_CONFDIR}"
103 APACHE_MODULES_CONFDIR="${APACHE2_MODULES_CONFDIR}"
104 APACHE_VHOSTSDIR="${APACHE2_VHOSTSDIR}"
105 APACHE_MODULESDIR="${APACHE2_MODULESDIR}"
106}
107
108# @FUNCTION: doesnt_use_apache
109# @DESCRIPTION:
110# sets up all of the environment variables required for optional apache usage
111doesnt_use_apache() {
112 debug-print-function $FUNCNAME $*
113
114 APACHE_VERSION="0"
115 USE_APACHE="0"
116}
117
118# ==============================================================================
119# PUBLIC FUNCTIONS
120# ==============================================================================
121
122# @FUNCTION: want_apache
123# @DESCRIPTION:
92## An ebuild calls this to get the dependency information 124# An ebuild calls this to get the dependency information for optional apache-2.x
93## for apache-1.x. An ebuild should use this in order for 125# support.
94## future changes to the build infrastructure to happen
95## seamlessly. All an ebuild needs to do is include the
96## line need_apache1 somewhere.
97####
98need_apache1() { 126want_apache() {
99 debug-print-function need_apache1 127 debug-print-function $FUNCNAME $*
100 128
129 IUSE="${IUSE} apache2"
101 DEPEND="${DEPEND} ${APACHE1_DEPEND}" 130 DEPEND="${DEPEND} ${WANT_APACHE_DEPEND}"
102 APACHE_VERSION='1' 131 RDEPEND="${RDEPEND} ${WANT_APACHE_DEPEND}"
103}
104 132
105#### 133 if use apache2 ; then
106## need_apache2 134 uses_apache2
107## 135 else
136 doesnt_use_apache
137 fi
138}
139
140# @FUNCTION: need_apache2
141# @DESCRIPTION:
108## An ebuild calls this to get the dependency information 142# An ebuild calls this to get the dependency information for apache-2.x. An
109## for apache-2.x. An ebuild should use this in order for 143# ebuild should use this in order for future changes to the build infrastructure
110## future changes to the build infrastructure to happen
111## seamlessly. All an ebuild needs to do is include the 144# to happen seamlessly. All an ebuild needs to do is include the line
112## line need_apache1 somewhere. 145# need_apache2 somewhere.
113####
114need_apache2() { 146need_apache2() {
115 debug-print-function need_apache2 147 debug-print-function $FUNCNAME $*
116 148
117 DEPEND="${DEPEND} ${APACHE2_DEPEND}" 149 DEPEND="${DEPEND} ${APACHE2_DEPEND}"
118 APACHE_VERSION='2' 150 RDEPEND="${RDEPEND} ${APACHE2_DEPEND}"
151 uses_apache2
119} 152}
120 153
154# @FUNCTION: need_apache2_0
155# @DESCRIPTION:
156# Works like need_apache2 above, but its used by modules that only support
157# apache 2.0 and do not work with higher versions.
158need_apache2_0() {
159 debug-print-function $FUNCNAME $*
160
161 DEPEND="${DEPEND} ${APACHE2_0_DEPEND}"
162 RDEPEND="${RDEPEND} ${APACHE2_0_DEPEND}"
163 uses_apache2
164}
165
166# @FUNCTION: need_apache2_2
167# @DESCRIPTION:
168# Works like need_apache2 above, but its used by modules that only support
169# apache 2.2 and do not work with lower versions.
170need_apache2_2() {
171 debug-print-function $FUNCNAME $*
172
173 DEPEND="${DEPEND} ${APACHE2_2_DEPEND}"
174 RDEPEND="${RDEPEND} ${APACHE2_2_DEPEND}"
175 uses_apache2
176}
177
178# @FUNCTION: need_apache
179# @DESCRIPTION:
180# Legacy alias for need_apache2
121need_apache() { 181need_apache() {
122 debug-print-function need_apache
123
124 IUSE="${IUSE} apache2"
125 if useq apache2; then
126 need_apache2 182 need_apache2
183}
184
185# @FUNCTION: apr_config
186# @DESCRIPTION:
187# Version magic to get the correct apr-config binary based on the (probably)
188# installed version of apache. This is needed to get modules to link to the
189# same apr/apu as apache (i.e. link 0.9 for 2.0, 1.x for 2.2)
190apr_config() {
191 debug-print-function $FUNCNAME $*
192
193 local default="${1:-1}"
194 if [[ "${USE_APACHE}" == "2" ]]; then
195 if has_version ${APACHE2_0_DEPEND}; then
196 echo apr-config
197 else
198 echo apr-1-config
199 fi
127 else 200 else
128 need_apache1 201 if [[ "${default}" == "0" ]]; then
202 echo apr-config
203 elif [[ "${default}" == "1" ]]; then
204 echo apr-1-config
205 else
206 die "Unknown version specifier: ${default}"
207 fi
129 fi 208 fi
130} 209}
131 210
211# @FUNCTION: apu_config
212# @DESCRIPTION:
213# Version magic to get the correct apu-config binary based on the (probably)
214# installed version of apache. This is needed to get modules to link to the
215# same apr/apu as apache (i.e. link 0.9 for 2.0, 1.x for 2.2)
216apu_config() {
217 debug-print-function $FUNCNAME $*
218
219 local default="${1:-1}"
220 if [[ "${USE_APACHE}" == "2" ]]; then
221 if has_version ${APACHE2_0_DEPEND}; then
222 echo apu-config
223 else
224 echo apu-1-config
225 fi
226 else
227 if [[ "${default}" == "0" ]]; then
228 echo apu-config
229 elif [[ "${default}" == "1" ]]; then
230 echo apu-1-config
231 else
232 die "Unknown version specifier: ${default}"
233 fi
234 fi
235}

Legend:
Removed from v.1.6  
changed lines
  Added in v.1.35

  ViewVC Help
Powered by ViewVC 1.1.20